import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;


public class extended extends Applet{

    Button button1;
    String filename;
    TextField text1, text2;

    public static void main(String args[])
    {
        extendedFrame frame = new extendedFrame("The extended application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        extended applet = new extended();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse this link:");
        add(button1);
        text1 = new TextField(20);
        text1.setText("link1");
        add(text1);
        text2 = new TextField(30);
        add(text2);
    }

    public boolean action (Event e, Object o)
    {

        URL url = null;
        filename = "file:////c://xml//extended//extended.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot());
        }
        return true;
    }


    void doTree(Element elem)
    {
        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() == com.ms.xml.Element.ELEMENT){

                if(elem2.getTagName().equals("LOCATOR") && elem2.getAttribute("TITLE").equals(text1.getText())){

                    URL url = null;

                    try {
                        url = new URL(elem2.getAttribute("HREF"));
                    } catch (MalformedURLException e1) {
                        System.out.println("Cannot create url for: " + filename);
                        System.exit(0);
                    }
            
                    Document d = new Document(); 

                    try {
                        d.load(url);
                    } 
                    catch (ParseException e3) {
                        d.reportError(e3, System.out);
                    }

                    if (d != null) {
                        text2.setText(d.getText());
                    }
                }
                doTree(elem2);
            }
        }
    }
}    

class extendedFrame extends Frame
{
    public extendedFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

