import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;


public class searcher extends Applet{

    static String fileName;    
    Label firstNameLabel, lastNameLabel;
    TextField text1, text2, text3;
    Button button1;
    Document d;
    int maxRecordNumber = 0;
               
    public static void main(String args[])
    {
        searcherFrame frame = new searcherFrame("The searcher application");

        frame.show();
        frame.hide();
        frame.resize(320, 300);

        searcher applet = new searcher();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        firstNameLabel = new Label("First Name:");
        add(firstNameLabel);
        text1 = new TextField(24);
        add(text1);
        lastNameLabel = new Label("Last Name:");
        add(lastNameLabel);
        text2 = new TextField(24);
        add(text2);
        button1 = new Button("Search for this first name:");
        add(button1);
        text3 = new TextField(10);
        add(text3);

        URL url = null;
        try {
            url = new URL("file:////c://xml//searcher//searcher.xml");
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + fileName);
            System.exit(0);
        }
            
        d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            maxRecordNumber = d.getRoot().numElements() - 1;
        }
    }

    public boolean action (Event e, Object o){

        if(e.target.equals(button1)){  //The Find button

            Element root = d.getRoot();
            Element elem = null, elem2 = null, elem3 = null;
            Enumeration enum = root.getChildren();

            for(int index = 0; index <= maxRecordNumber; index++){
                elem = (Element)enum.nextElement();

                Enumeration enum2 = elem.getChildren();

                elem2 = (Element)enum2.nextElement();
                elem3 = (Element)enum2.nextElement();

                if (elem3.getTagName().equals("FIRSTNAME") && elem3.getText().equals(text3.getText()) ) {
                    text1.setText(elem3.getText());
                    text2.setText(elem2.getText());
                }
            }
        }
        return true;
    }

}    

class searcherFrame extends Frame
{
    public searcherFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

