import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class caps extends Applet{

    Button button1;
    static String fileName;    
    static String displayStrings[] = new String[100];
    static int numberDisplayLines = 0;
    boolean doCaps = false; 

    public static void main(String args[])
    {
        capsFrame frame = new capsFrame("The caps application");

        frame.show();
        frame.hide();
        frame.resize(400, 400);

        caps applet = new caps();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        try {
            url = new URL("file:////c://xml//caps//caps.xml");
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + fileName);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot());
            repaint();
        }
        return true;
    }


    void doTree(Element elem)
    {
        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() != com.ms.xml.Element.ELEMENT){

                if(doCaps){
                    displayStrings[numberDisplayLines++] = elem2.getText().toUpperCase();
                }
                else{
                    displayStrings[numberDisplayLines++] = elem2.getText().toLowerCase();
                }

            }
            else{
                boolean doCapsOld = doCaps;

                if(elem2.getTagName().equals("UPPER")){
                    doCaps = true;
                }
                if(elem2.getTagName().equals("LOWER")){
                    doCaps = false;
                }

                doTree(elem2);
                doCaps = doCapsOld;
            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 0;
        FontMetrics fontmetrics = getFontMetrics(getFont());

        for(int index = 0; index < numberDisplayLines; index++){
            y += fontmetrics.getHeight();
            g.drawString(displayStrings[index], 0, y);
        }
    }
}    

class capsFrame extends Frame
{
    public capsFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }

}

