import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class indenter extends Applet{

    Button button1;
    static String filename;    
    static String displayStrings[] = new String[100];
    static int numberDisplayLines = 0;

    public static void main(String args[])
    {
        indenterFrame frame = new indenterFrame("The indenter application");

        frame.show();
        frame.hide();
        frame.resize(400, 400);

        indenter applet = new indenter();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        try {
            url = new URL("file:////c://xml//indenter//indenter.xml");
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot(), "");
            repaint();
        }
            return true;
    }

    void doTree(Element elem, String indent)
    {
        String ind = "";

        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() != com.ms.xml.Element.ELEMENT){
                displayStrings[numberDisplayLines++] = indent + elem2.getText();
            }
            else{
                if(elem2.getTagName().equals("INDENTDOUBLE")){
                    ind = indent + "    ";
                }
                if(elem2.getTagName().equals("INDENT")){
                    ind = indent + "  ";
                }
                doTree(elem2, ind);
            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 0;
        FontMetrics fontmetrics = getFontMetrics(getFont());

        for(int index = 0; index < numberDisplayLines; index++){
            y += fontmetrics.getHeight();
            g.drawString(displayStrings[index], 0, y);
        }
    }
}    

class indenterFrame extends Frame
{
    public indenterFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

