import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;


public class locator extends Applet{

    static String filename;    
    TextField text1;
    Button button1;
    String rootString = new String("#ROOT()");

    public static void main(String args[])
    {
        locatorFrame frame = new locatorFrame("The locator application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        locator applet = new locator();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        text1 = new TextField(20);
        add(text1);
        button1 = new Button("Display the linked-to text");
        add(button1);
    }

    public boolean action (Event e, Object o)
    {
        String locator = "";

        URL url = null;
        filename = "file:////c://xml//locator//locator.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e2) {
            d.reportError(e2, System.out);
        }

        if (d != null) {
            Element root = d.getRoot();
            Enumeration enum = root.getChildren();
            while (enum.hasMoreElements()) {
                Element elem = (Element)enum.nextElement();
                if (elem.getTagName().equals("LOCATOR")) {
                    URL url2 = null;
                    try {
                        locator = new String(elem.getAttribute("HREF"));
                        url2 = new URL(locator.substring(0, 
                            locator.indexOf("#")));
                    } 
                    catch (MalformedURLException e3) {
                        System.out.println("Cannot create URL for: " + 
                            elem.getAttribute("HREF"));
                        System.exit(0);
                    }
            
                    Document d2 = new Document(); 

                    try {
                        d2.load(url2);
                    } 
                    catch (ParseException e4) {
                        d2.reportError(e4, System.out);
                    }

                    Element newRoot = d2.getRoot();
           
                    int number = 0;
                    String tagName = "";

                    locator = 
                        locator.substring(locator.indexOf(rootString) + 
                        rootString.length());

                    int begin = locator.indexOf("(", 0);

                    Element elem2 = null; 
                    Enumeration enum2 = null;

                    while(begin != -1){
                        begin++;
                        number = 
                            Integer.parseInt(locator.substring(begin, 
                            ++begin));
                        tagName = locator.substring(++begin, 
                            locator.indexOf(")", begin));

                        enum2 = newRoot.getChildren();

                        int index = 0;

                        while (enum2.hasMoreElements() && index <= number) {
                            elem2 = (Element)enum2.nextElement();
                            if(elem2.getTagName().equals(tagName)){
                                index++;
                                newRoot = elem2;
                            }
                        }
                        begin = locator.indexOf("(", begin);
                    }
                    text1.setText(newRoot.getText());
                }
            }
        }
        return true;
    }
}    

class locatorFrame extends Frame
{
    public locatorFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

